module MOTOR_CNT(input CLK, RESET, DIR_INPUT, input [2:0] SET_SW, output reg [1:0] MOTOR_OUT);
reg [20:0] tmp_cnt;
reg [21:0] set_signal;
reg DIR, EN;

parameter CNT_MAX = 2000000; // 20 ms

always @(posedge CLK or posedge RESET)
	if (RESET == 1'b1)
		tmp_cnt <= 12'h000;
	else if (tmp_cnt == (CNT_MAX - 1))
		tmp_cnt <= 12'h000;
	else
		tmp_cnt <= tmp_cnt + 12'h1;

always @(*)
begin
	case (SET_SW)
		3'b000 : set_signal = (CNT_MAX*1)/8;
		3'b001 : set_signal = (CNT_MAX*2)/8;
		3'b010 : set_signal = (CNT_MAX*3)/8;
		3'b011 : set_signal = (CNT_MAX*4)/8;
		3'b100 : set_signal = (CNT_MAX*5)/8;
		3'b101 : set_signal = (CNT_MAX*6)/8;
		3'b110 : set_signal = (CNT_MAX*7)/8;
		3'b111 : set_signal = (CNT_MAX*8)/8;
		default : set_signal = 0;
	endcase
end

always @(posedge CLK or posedge RESET)
	if (RESET == 1'b1)
		EN <= 1'b0;
	else
		begin
			if (tmp_cnt <= set_signal[20:0])
				EN <= 1'b1;
			else
				EN <= 1'b0;
		end
		
always @(posedge CLK or posedge RESET)
	if (RESET == 1'b1)
		MOTOR_OUT <= 2'b00;
	else
		begin
			if (DIR_INPUT == 1'b0)
				MOTOR_OUT <= {1'b0, EN};
			else
				MOTOR_OUT <= {EN, 1'b0};
		end
endmodule
